
(setq loaddirectories* (cons "$pxnk/lap/" loaddirectories*))


(setq *usermode nil)

%---------------------------------------------------


(remprop 'bndstkupperbound 'registername) % r15
(remprop 'bndstklowerbound 'registername) % r14

(remprop 'bndstkupperbound '*other-name) % r15
(remprop 'bndstklowerbound '*other-name) % r14
%-------------------------------------------------------------------

(DefCMacro *Call
       ((InternallyCallableP) (lda (Reg r27) (InternalEntry ArgOne) )
                                (jsr (reg returnaddr)
                                         (displacement (Reg r27) nil))
                                (ldq (reg r27) (displacement (reg st) 8)))
       ((asmp)  (lda (Reg t3) (idloc ArgOne))
                 (s8addq  (reg t3) (reg SYMFNCcenter) (reg r27))
                 (ldq (reg r27) (displacement (reg r27) 0))
                 (jsr (reg returnaddr) (displacement (reg r27) nil))
                 (ldgp (reg gp) (displacement (reg r26) 0) )
                 (*MOVE (REG r14)(REG RETURNADDR))
                   )                     
     (       (lda (Reg t3) (idloc ArgOne))
                 (s8addq  (reg t3) (reg SYMFNCcenter) (reg r27))
                 (ldq (reg r27) (displacement (reg r27) 0))
                 (jsr (reg returnaddr) (displacement (reg r27) nil))
                 (lda (reg r27) (displacement (reg returnaddr) nearestentry*))
                 (*MOVE (REG r14)(REG RETURNADDR))
                 templabel ))

(de freep (x) nil)

(de *ALLOC (framesize)
    (setq NAlloc!* framesize)
    (cond ((freep (times2 AddressingUnitsPerItem framesize)) NIL)
          (t  (when (eq 1 (land framesize 1)) % set st on double word boundary
                         (setq framesize (add1 framesize)))
              (if (asmp)
             `((ldgp (reg gp) (displacement (reg r27) 0))
                (lda (reg st)
                    (displacement (reg st)
                         ,(minus (plus2 16 (times2 8 framesize)))))
                (stq (reg returnaddr) (displacement (reg st) 0))
                (*MOVE (REG r14)(REG RETURNADDR)))
             `((lda (reg st)
                    (displacement (reg st)
                         ,(minus (plus2 16 (times2 8 framesize)))))
                (stq (reg r27) (displacement (reg st) 8))
                (stq (reg returnaddr) (displacement (reg st) 0))
                (*MOVE (REG r14)(REG RETURNADDR))
                   )))
)   )
%-------------------------------------------------------------------    
                        
(De *LamBind (Regs Fluids)

 % be careful, code is somewhat tricky

 (prog (n lng list cregs cfluids cadrcfluids genlabel initload freeregs)
      (setq genlabel (gensym))
      (setq n 0)
      (setq Regs (rest Regs))   % Remove "Registers" from the front
      (setq Fluids (rest fluids)) % Remove NONLOCALVARS
      (setq lng (wtimes2 (length Regs) 16)) % two words per BndStk entry *4

   %looking for free register to preload values of fluid s

      (setq freeregs (mapcan '((reg 1)(reg 2)(reg 3)(reg 4)(reg 5))
		   (function (lambda (x)
				(cond ((member x regs) nil)
				       (t (cons x nil))
      )              ) )         )  )
      (setq freeregs (nconc (list '(reg T3) '(reg T4)) freeregs))
      (setq cfluids fluids) % copy of fluids

preload  (setq initload
       (progn (setq cadrcfluids
		(nconc cadrcfluids (cons (car freeregs) nil)))
	(nconc initload `((*move ,(car cfluids) ,(car freeregs))))
       )   )
       (setq freeregs (cdr freeregs))
       (setq cfluids (cdr cfluids))

       (cond ((and freeregs cfluids) (go preload)))

       (setq freeregs (nconc cadrcfluids cfluids)) %end of preloadcode

       % freeregs contains the list of preloaded regs
       % and not preloaded fluids if those exist

      (setq list `((*wplus3 (reg t2) (Reg bndstkptr) ,lng )
		   (*move (Reg bndstkptr) (Reg t1))
                   (*move ($fluid BndstkUpperbound)(reg t5))
                   (subq (reg t5) (reg t2) (reg t5))
                   (bgt (reg t5) ,genlabel)
                   (*call Bstackoverflow)
                  ,genlabel  
		   (*move (Reg t2) (Reg bndstkptr)))) %start of code

      (setq list (append initload list))

  loop
      (setq cregs (car Regs))
      (setq cfluids (car Fluids))
      (setq cadrcfluids (cadr cfluids))
      (when (or (eq cadrcfluids 't) (eq cadrcfluids 'nil))
	   (stderror "T and NIL cannot be rebound"))
      (setq n (wplus2 n 16))
      (Setq list (append list
    `((*move ,(car freeregs) (displacement (Reg t1) ,n))
       (*move (quote ,Cadrcfluids)
		   (displacement (reg t1) ,(wplus2 n -8)))
       (*move ,cregs ,cfluids)
      )          ))
      (setq fluids (cdr Fluids))
      (setq freeregs (cdr freeregs))
      (cond ((setq regs (cdr Regs)) (go loop)))
      (return list)
)    )

(defcmacro !*lambind)

(De *ProgBind (Fluids)

 % be careful, code is somewhat tricky

 (prog (n lng list cfluids cadrcfluids genlabel initload freeregs)
      (setq genlabel (gensym))
      (setq n 0)
      (setq Fluids (rest fluids)) % Remove NONLOCALVARS
      (setq lng (wtimes2 (length Fluids) 16)) % two words per BndStk entry
					 % * 8 addressingunits
      (setq freeregs '((reg t3)(reg T4)(reg 1)(reg 2)(reg 3)(reg 4)(reg 5)))
      (setq cfluids fluids) % copy of fluids

preload  (setq initload
       (progn (setq cadrcfluids
		(nconc cadrcfluids (cons (car freeregs) nil)))
	(nconc initload `((*move ,(car cfluids) ,(car freeregs))))
       )   )
       (setq freeregs (cdr freeregs))
       (setq cfluids (cdr cfluids))

       (cond ((and freeregs cfluids) (go preload)))

       (setq freeregs (nconc cadrcfluids cfluids)) %end of preloadcode

       % freeregs contains the list of preloaded regs
       % and not preloaded fluids if those exist


	(setq list `((*wplus3 (reg t2) (Reg bndstkptr) ,lng )
		(*move  (Reg bndstkptr)  (Reg t1))
                (*move ($fluid BndstkUpperbound)(reg t5))
                (subq (reg t5) (reg t2) (reg t5))
		(bgt (reg t5) ,genlabel)
		(*call Bstackoverflow)
	        ,genlabel
		(*move (Reg t2) (Reg bndstkptr)))) %start of code


     (setq list (append initload list))

 loop
      (setq cfluids (car Fluids))
      (setq cadrcfluids (cadr cfluids))
      (when (or (eq cadrcfluids 't) (eq cadrcfluids 'nil))
	   (stderror "T and NIL cannot be rebound"))
      (setq n (wplus2 n 16))
      (Setq list (append list
	    `((*move ,(car freeregs) (displacement (Reg t1) ,n))
	       (*move (quote ,Cadrcfluids)
			   (displacement (reg t1)  ,(wplus2 n -8)))
	       (*move (quote nil) ,cfluids)
      )          ))
      (setq freeregs (cdr freeregs))
      (cond ((setq Fluids (cdr Fluids)) (go loop)))
      (return list)
)    )
(defcmacro *progbind)

(De *FreeRstr (Fluids)

 (prog (n lng list cfluids listfluids genlabel initload freeregs)
      (setq genlabel (gensym))
      (setq n 0)
      (setq Fluids (rest fluids)) % Remove NONLOCALVARS
      (setq lng (wtimes2 (length Fluids) 2)) % two words per BndStk entry
      (setq freeregs '((reg t3)(reg t4)(reg 2)(reg 3)(reg 4)(reg 5)))
      (setq cfluids fluids) % copy of fluids
      (setq n (wtimes2 8 (wdifference 2 lng)))
      (setq lng (wtimes2 lng 8)) % * addressingunitperitem
      (setq initload (list '(*move (fluid Bndstkptr) (reg t1))))

preload  (setq initload
       (progn (setq listfluids
	       (if freeregs
		(nconc listfluids (cons (car freeregs) nil))
		(nconc listfluids (cons nil nil))) )
	(nconc initload
	 (if freeregs
	 `((*move (displacement (reg t1) ,n) ,(car freeregs))) nil)
       )   ))
       (setq n (wplus2 n 16))
       (when freeregs (setq freeregs (cdr freeregs)))
       (setq cfluids (cdr cfluids))

       (cond (cfluids (go preload)))

       (setq freeregs listfluids ) %end of preloadcode

       % freeregs contains the list of preloaded regs
       % and nil if not enough regs available

      (setq list `((*wdifference3 (Reg t2) (reg t1) ,lng)
                (*move ($fluid BndstkLowerBound)(reg t5))
		(subq (reg t2)(reg t5) (reg t5))
		(bge (reg t5) ,genlabel)
		(*call  Bstackunderflow)
		,genlabel
		(*move (Reg t2) ($fluid BndstkPtr)))) %start of code

     (setq list (append initload list))
     (setq n 0)

 loop
      (setq cfluids (car Fluids))
      (setq n (wplus2 n 16))

  % insert reloaded register or memory reference

      (setq list (append list
	   (if (car freeregs) `((*move ,(car freeregs) ,cfluids ))
	`((*move (displacement (Reg t2) ,n) ,cfluids )))

      )          )
      (setq freeregs (cdr freeregs))
      (cond ((setq Fluids (cdr Fluids)) (go loop)))
      (return list)
)    )
