 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         CONVEX-CROSS
% Description:
% Author:
% Created:
% Modified:
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1988, Konrad Zuse Zentrum Berlin
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% support for crosscompilation
 
 
%%%%% memory accesses with byte addressing
 
(de lapputmem (where what)
      (putmem where what))
 
(de lapgetmem (where)
      (getmem  where ))
 
(de lapgtbps (howmuch)  % number ofwords; result as byte address
     (gtbps howmuch))
 
(de lapgtwarray (howmuch)  % number ofwords; result as byte address
    (gtwarray howmuch))

(de faslstrbase (u) (strbase u))

 
%%%%%%%%% diagnostics
 
(de xdumpo (u n)
     (prog (outputbase!* byteaddr h1 h2 w c)
         (setq outputbase* 10)
         (prin2 u) (prin2 "==") (prin2t (times u 8))
         (setq outputbase* 16)
loop     (setq byteaddr (times u 8))
         (setq c (getmem u))
         (setq h1(wrshift c 32))
         (setq h2(wdifference c (wlshift h1  32)))
         (setq h1 (wplus2 h1 16#100000000))
         (setq h2 (wplus2 h2 16#100000000))
         (prin2 byteaddr)          (tab 20) (prin2t h1)
         (prin2 (plus byteaddr 4)) (tab 20) (prin2t h2)
         (setq n (wdifference n 1))
         (setq u (wplus2 u 1))
         (when (leq n 0) (return nil))
         (go loop) ))
 
(de xdumpfile(u n)
     (prog (outputbase!* byteaddr h1 h2 w c)
         (setq byteaddr 0)
         (setq outputbase* 10)
         (prin2t u) (setq u (faslopenread u))
         (setq outputbase* 16)
loop
         (setq c (faslreadword u))
         (setq h1(wrshift c 32))
         (setq h2(wdifference c (wlshift h1  32)))
         (setq h1 (wplus2 h1 16#100000000))
         (setq h2 (wplus2 h2 16#100000000))
         (prin2 byteaddr)          (tab 15) (prin2  h1)
                                   (tab 30) (prin2t h2)
         (setq n (wdifference n 1))
         (setq byteaddr (wplus2 byteaddr 8))
         (when (leq n 0) (return nil))
         (go loop) ))
(when (null(getd ffwwbb)) (copyd 'ffwwbb 'faslwriteblock))
 
(de faslwriteblock(a b c)
        (ffwwbb a (wrshift b 3) c))
 
 
