
	.section	".text",#alloc,#execinstr
	.align	8
	.skip	16

	! block 0
	.type	power,2
power:
	save	%sp,-112,%sp
	st	%i1,[%fp+72]
	st	%i0,[%fp+68]

	! block 1
.L73:

! File /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c:
!    1	/*
!    2	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!    3	%
!    4	% File:         bpsheap.c
!    5	% Description:  Code to dynamically set up bps and heap structures
!    6	% Author:       RAM, HP/FSD
!    7	% Created:      9-Mar-84
!    8	% Modified:
!    9	% Mode:         Text
!   10	% Package:
!   11	%
!   12	% (c) Copyright 1987, University of Utah, all rights reserved.
!   13	%
!   14	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!   15	%
!   16	% Revisions:
!   17	%
!   18	% 11-Aug-88 (Julian Padget)
!   19	%  Added initialization of BPSLOWERBOUND in setupbps().
!   20	% 07-Apr-87 (Harold Carr & Leigh Stoller)
!   21	%  Put in error checking to ensure that the memory pointers will fit in
!   22	%   info field of the lisp item.
!   23	% 21-Dec-86 (Leigh Stoller)
!   24	%  Added allocatemorebps function, called from try-other-bps-spaces in
!   25	%   allocators.sl.
!   26	% 18-Dec-86 (Leigh Stoller)
!   27	%  Changed to newer model. Bps is now defined in bps.c so that unexec can
!   28	%  alter the text/data boundry. Took out code that allowed command line
!   29	%  modification of bpssize. (Now set in the Makefile). Added setupbps()
!   30	%  that initialzes NEXTBPS and LASTBPS.
!   31	% 20-Sep-86 (Leigh Stoller)
!   32	%  Removed assembler alias statements because they are not portable. Instead,
!   33	%  a sed script will be used to convert the _variables of C to VARIABLES of
!   34	%  PSL.
!   35	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!   36	*/
!   37	
!   38	#include <stdio.h>
!   39	
!   40	/* Use 1 if using compacting collector ($pxnk/compact-gc.sl).
!   41	   Use 2 if using copying collector ($pnk/copying-gc.sl).
!   42	   Be sure to update $pxnk/load-psl.sl to include correct collector. */
!   43	
!   44	#define MINSIZE        5000000  /* Default total in number of bytes. */
!   45	#define MALLOCSIZE     500000   /* Default size for OS support functions. */
!   46	#define EXTRABPSSIZE   100000   /* Minimum amount to increase bps by. */
!   47	#define MINIMUMHEAPADD 20000    /* Minimum amount to increase heap by */
!   48	
!   50	#ifndef BPSSIZE
!   51	#define BPSSIZE          800000    /* Default bps size in number of bytes */
!   52	#endif
!   53	
!   54	char *  imagefile ;
!   55	int     max_image_size;
!   56	int     oldbreakvalue;
!   57	
!   58	extern int  alreadysetupbpsandheap;
!   59	extern int  HASHTABLE;
!   60	extern int  VIVAREA;
!   61	extern char bps[];
!   62	extern int  LASTBPS;
!   63	extern int  NEXTBPS;
!   64	extern int  BPSLOWERBOUND;
!   65	
!   66	extern int  HEAPLOWERBOUND;
!   67	extern int  HEAPUPPERBOUND;
!   68	extern int  HEAPLAST;
!   69	extern int  HEAPTRAPBOUND;
!   70	
!   71	extern int  OLDHEAPUPPERBOUND;
!   72	extern int  OLDHEAPLOWERBOUND;
!   73	extern int  OLDHEAPLAST;
!   74	extern int  OLDHEAPTRAPBOUND;
!   75	
!   76	extern int  SYMVAL;
!   77	
!   78	/* Write this ourselves to keep from including half the math library */
!   79	static power(x, n)
!   80	     int x, n;
!   81	{
!   82	  int i, p;
!   83	
!   84	  p = 1;

	mov	1,%l0
	st	%l0,[%fp-12]

!   85	  for (i = 1; i <= n; ++i)

	mov	1,%l0
	st	%l0,[%fp-8]
	ld	[%fp-8],%l1
	ld	[%fp+72],%l0
	cmp	%l1,%l0
	bg	.L76
	nop

	! block 2
.L77:
.L74:

!   86	    p = p * x;

	ld	[%fp-12],%l0
	ld	[%fp+68],%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	.mul
	nop
	mov	%o0,%l0
	st	%l0,[%fp-12]
	ld	[%fp-8],%l0
	add	%l0,1,%l0
	st	%l0,[%fp-8]
	ld	[%fp-8],%l1
	ld	[%fp+72],%l0
	cmp	%l1,%l0
	ble	.L74
	nop

	! block 3
.L78:
.L76:

!   87	  return(p);

	ld	[%fp-12],%l0
	st	%l0,[%fp-4]
	ba	.L72
	nop

	! block 4
.L72:
	ld	[%fp-4],%l0
	mov	%l0,%i0
	jmp	%i7+8
	restore
	.size	power,(.-power)
	.align	8
	.align	8
	.skip	16

	! block 0

	.global	setupbpsandheap
	.type	setupbpsandheap,2
setupbpsandheap:
	save	%sp,-296,%sp
	st	%i1,[%fp+72]
	st	%i0,[%fp+68]

	! block 1
.L82:

! File /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c:
!   88	}
!   89	
!   90	setupbpsandheap(argc,argv)
!   91	     int argc;
!   92	     char *argv[];
!   93	{ int ohl,ohtb,ohlb,ohub,hl,htb,hlb,hub;
!   94	  int memset = 0; int feder = 200000;

	mov	0,%l0
	st	%l0,[%fp-40]
	sethi	%hi(200000),%l0
	or	%l0,%lo(200000),%l0
	st	%l0,[%fp-44]

!   95	  FILE * imago;
!   96	  int headerword [9];
!   97	  int    i, total, bpssize, heapsize, mallocsize;
!   98	  int    current_size_in_bytes, heapsize_in_bytes;
!   99	  double bpspercent, heappercent;
!  100	  char   *argp, *scanptr, *scanformat;
!  101	  int ii1,ii2,ii3,ii4,ii5,ii6,ii7,ii8,ii9,ii10,ii11;
!  102	
!  103	  total        = MINSIZE;

	sethi	%hi(5000000),%l0
	or	%l0,%lo(5000000),%l0
	st	%l0,[%fp-92]

!  104	  mallocsize    = MALLOCSIZE;

	sethi	%hi(500000),%l0
	or	%l0,%lo(500000),%l0
	st	%l0,[%fp-104]

!  106	  for (i=1; i<argc-1; i++)

	mov	1,%l0
	st	%l0,[%fp-88]
	ba	.L86
	nop

	! block 2
.L83:

!  107	    {
!  108	      argp = argv[i];

	ld	[%fp+72],%l2
	ld	[%fp-88],%l0
	sll	%l0,2,%l1
	add	%l2,%l1,%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-132]

!  109	      if (*argp++ == '-')

	ld	[%fp-132],%l0
	ldsb	[%l0+0],%l0
	sll	%l0,24,%l0
	sra	%l0,24,%l0
	st	%l0,[%fp-188]
	ld	[%fp-132],%l0
	add	%l0,1,%l0
	st	%l0,[%fp-132]
	ld	[%fp-188],%l0
	st	%l0,[%fp-192]
	ld	[%fp-192],%l0
	cmp	%l0,45
	bne	.L87
	nop

	! block 3
.L88:

!  110	        {
!  111	          scanformat = "";

	sethi	%hi(.L89),%l0
	or	%l0,%lo(.L89),%l0
	st	%l0,[%fp-140]

!  112	          switch (*argp++) {

	ba	.L91
	nop

	! block 4
.L92:

!  113	            case 't': scanptr = (char *)&total;

	add	%fp,-92,%l0
	st	%l0,[%fp-136]

!  114	                      memset = 1;

	mov	1,%l0
	st	%l0,[%fp-40]

!  115	                      switch (*argp) {

	ba	.L94
	nop

	! block 5
.L95:

!  116	                case 'x': scanformat = "%x";

	sethi	%hi(.L96),%l0
	or	%l0,%lo(.L96),%l0
	st	%l0,[%fp-140]

!  117	                      break;

	ba	.L93
	nop

	! block 6
.L97:

!  118	                        case 'd': scanformat = "%d";

	sethi	%hi(.L98),%l0
	or	%l0,%lo(.L98),%l0
	st	%l0,[%fp-140]

!  119	                                  break;

	ba	.L93
	nop

	! block 7

!  120	              }

.L94:
	ld	[%fp-132],%l0
	ldsb	[%l0+0],%l0
	sll	%l0,24,%l0
	sra	%l0,24,%l0
	cmp	%l0,100
	be	.L97
	nop

	! block 8
	cmp	%l0,120
	be	.L95
	nop

	! block 9
.L99:
.L93:

!  121	                      break;

	ba	.L90
	nop

	! block 10
.L100:

!  122	            case 'm': scanptr = (char *)&mallocsize;

	add	%fp,-104,%l0
	st	%l0,[%fp-136]

!  123	                      switch (*argp) {

	ba	.L102
	nop

	! block 11
.L103:

!  124	                        case 'x': scanformat = "%x";

	sethi	%hi(.L104),%l0
	or	%l0,%lo(.L104),%l0
	st	%l0,[%fp-140]

!  125	                                  break;

	ba	.L101
	nop

	! block 12
.L105:

!  126	                        case 'd': scanformat = "%d";

	sethi	%hi(.L106),%l0
	or	%l0,%lo(.L106),%l0
	st	%l0,[%fp-140]

!  127	                                  break;

	ba	.L101
	nop

	! block 13

!  128	                      }

.L102:
	ld	[%fp-132],%l0
	ldsb	[%l0+0],%l0
	sll	%l0,24,%l0
	sra	%l0,24,%l0
	cmp	%l0,100
	be	.L105
	nop

	! block 14
	cmp	%l0,120
	be	.L103
	nop

	! block 15
.L107:
.L101:

!  129	                      break;

	ba	.L90
	nop

	! block 16
.L108:

!  130	           case 'f': imagefile = argv[i+1]; break;

	ld	[%fp+72],%l2
	ld	[%fp-88],%l0
	sll	%l0,2,%l1
	add	%l2,%l1,%l0
	add	%l0,4,%l0
	ld	[%l0+0],%l1
	sethi	%hi(imagefile),%l0
	or	%l0,%lo(imagefile),%l0
	st	%l1,[%l0+0]
	ba	.L90
	nop

	! block 17
.L109:

!  131	           case 'g': scanptr = (char *)&feder;

	add	%fp,-44,%l0
	st	%l0,[%fp-136]

!  132	                     scanformat = "%d"; break;

	sethi	%hi(.L110),%l0
	or	%l0,%lo(.L110),%l0
	st	%l0,[%fp-140]
	ba	.L90
	nop

	! block 18

!  133	          }

.L91:
	ld	[%fp-132],%l0
	st	%l0,[%fp-196]
	ld	[%fp-132],%l0
	add	%l0,1,%l0
	st	%l0,[%fp-132]
	ld	[%fp-196],%l0
	ldsb	[%l0+0],%l0
	sll	%l0,24,%l0
	sra	%l0,24,%l0
	cmp	%l0,109
	bg	.L_y0
	nop

	! block 19
	be	.L100
	nop

	! block 20
	cmp	%l0,102
	be	.L108
	nop

	! block 21
	cmp	%l0,103
	be	.L109
	nop

	! block 22
	ba	.L111
	nop

	! block 23
.L_y0:
	cmp	%l0,116
	be	.L92
	nop

	! block 24
.L111:
.L90:

!  134	          if (*scanformat != 0)

	ld	[%fp-140],%l0
	ldsb	[%l0+0],%l0
	sll	%l0,24,%l0
	sra	%l0,24,%l0
	cmp	%l0,0
	be	.L112
	nop

	! block 25
.L113:

!  135	            sscanf(argv[i+1],scanformat,scanptr);

	ld	[%fp+72],%l2
	ld	[%fp-88],%l0
	sll	%l0,2,%l1
	add	%l2,%l1,%l0
	add	%l0,4,%l0
	ld	[%l0+0],%l0
	ld	[%fp-140],%l1
	ld	[%fp-136],%l2
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	call	sscanf
	nop

	! block 26
.L112:
.L87:

!  136	        }
!  137	    }   /* end of for loop -- arg vector searched */

	ld	[%fp-88],%l0
	add	%l0,1,%l0
	st	%l0,[%fp-88]

	! block 27
.L86:
	ld	[%fp-88],%l1
	ld	[%fp+68],%l0
	sub	%l0,1,%l0
	cmp	%l1,%l0
	bl	.L83
	nop

	! block 28
.L114:

!  139	  /* insure valid values */
!  140	  if (total == 0) total = MINSIZE;

	ld	[%fp-92],%l0
	cmp	%l0,0
	bne	.L115
	nop

	! block 29
.L116:
	sethi	%hi(5000000),%l0
	or	%l0,%lo(5000000),%l0
	st	%l0,[%fp-92]

	! block 30
.L115:

!  142	  if (mallocsize <= 0) mallocsize = MALLOCSIZE;

	ld	[%fp-104],%l0
	cmp	%l0,0
	bg	.L117
	nop

	! block 31
.L118:
	sethi	%hi(500000),%l0
	or	%l0,%lo(500000),%l0
	st	%l0,[%fp-104]

	! block 32
.L117:

!  146	  /* Reserve some space for C's usr of io buffers, etc. By mallocing then
!  147	     freeing, the memory is sbrk'ed onto the image, but available for future
!  148	     calls to malloc, which will not need to call sbrk again. */
!  149	
!  151	  ii1=malloc(0x408);

	mov	1032,%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-144]

!  152	  ii2=calloc(3,3);

	mov	3,%l0
	mov	3,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	calloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-148]

!  153	  ii3=malloc(0x408);

	mov	1032,%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-152]

!  154	  ii4=malloc(0x142c);

	sethi	%hi(5164),%l0
	or	%l0,%lo(5164),%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-156]

!  155	  ii5=malloc(0x1008);

	sethi	%hi(4104),%l0
	or	%l0,%lo(4104),%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-160]

!  156	  ii6=malloc(0x17);

	mov	23,%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-164]

!  157	  ii7=malloc(0x3);

	mov	3,%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-168]

!  158	  ii8=malloc(0x1068);

	sethi	%hi(4200),%l0
	or	%l0,%lo(4200),%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-172]

!  159	  ii9=malloc(0x28);

	mov	40,%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-176]

!  160	  ii10=malloc(0xc);

	mov	12,%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-180]

!  161	  ii11=malloc(0x384);

	mov	900,%l0
	mov	%l0,%o0
	call	malloc
	nop
	mov	%o0,%l0
	st	%l0,[%fp-184]

!  163	  external_user_homedir_string(); /* This is done by read-init-file */

	call	external_user_homedir_string
	nop

!  164	  external_anyuser_homedir_string("hugo"); 

	sethi	%hi(.L123),%l0
	or	%l0,%lo(.L123),%l0
	mov	%l0,%o0
	call	external_anyuser_homedir_string
	nop

!  166	  bpssize = BPSSIZE;

	sethi	%hi(4000000),%l0
	or	%l0,%lo(4000000),%l0
	st	%l0,[%fp-96]

!  168	  heapsize_in_bytes = total - bpssize;

	ld	[%fp-92],%l0
	ld	[%fp-96],%l1
	sub	%l0,%l1,%l0
	st	%l0,[%fp-112]

!  170	  /* On systems in which the image does not start at address 0, this won't
!  171	     really allocate the full maximum, but close enough. */
!  172	  current_size_in_bytes = (((int) sbrk(0))<<5)>>5;

	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l0
	sll	%l0,5,%l0
	sra	%l0,5,%l0
	st	%l0,[%fp-108]

!  173	  max_image_size = power(2, 27); /* 1 more than allowable size */

	mov	2,%l0
	mov	27,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	power
	nop
	mov	%o0,%l1
	sethi	%hi(max_image_size),%l0
	or	%l0,%lo(max_image_size),%l0
	st	%l1,[%l0+0]

!  175	  if ((heapsize_in_bytes + current_size_in_bytes) >= max_image_size) {

	ld	[%fp-112],%l0
	ld	[%fp-108],%l1
	add	%l0,%l1,%l1
	sethi	%hi(max_image_size),%l0
	or	%l0,%lo(max_image_size),%l0
	ld	[%l0+0],%l0
	cmp	%l1,%l0
	bl	.L125
	nop

	! block 33
.L126:

!  176	    heapsize_in_bytes = max_image_size - current_size_in_bytes;

	sethi	%hi(max_image_size),%l0
	or	%l0,%lo(max_image_size),%l0
	ld	[%l0+0],%l0
	ld	[%fp-108],%l1
	sub	%l0,%l1,%l0
	st	%l0,[%fp-112]

!  177	    total = heapsize_in_bytes + bpssize;

	ld	[%fp-112],%l0
	ld	[%fp-96],%l1
	add	%l0,%l1,%l0
	st	%l0,[%fp-92]

!  178	    printf("Size requested will result in pointer values larger than\n");

	sethi	%hi(.L127),%l0
	or	%l0,%lo(.L127),%l0
	mov	%l0,%o0
	call	printf
	nop

!  179	    printf(" PSL items can handle. Will allocate maximum size instead.\n\n");

	sethi	%hi(.L128),%l0
	or	%l0,%lo(.L128),%l0
	mov	%l0,%o0
	call	printf
	nop

	! block 34
.L125:

!  180	  }
!  181	
!  182	  heapsize =(heapsize_in_bytes / 8) * 4;  /* insure full words */

	ld	[%fp-112],%l0
	mov	8,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	.div
	nop
	mov	%o0,%l0
	sll	%l0,2,%l0
	st	%l0,[%fp-100]

!  183	  heappercent = ((float) (total - bpssize) / total) * 100.0;

	ld	[%fp-92],%l0
	ld	[%fp-96],%l1
	sub	%l0,%l1,%l0
	st	%l0,[%fp-200]
	ld	[%fp-200],%f2
	fitod	%f2,%f4
	ld	[%fp-92],%l0
	st	%l0,[%fp-200]
	ld	[%fp-200],%f2
	fitod	%f2,%f2
	fdivd	%f4,%f2,%f4
	sethi	%hi(.L_cseg0),%l0
	or	%l0,%lo(.L_cseg0),%l0
	ldd	[%l0+0],%f2
	fmuld	%f4,%f2,%f2
	std	%f2,[%fp-128]

!  184	  bpspercent  = ((float) bpssize / total) * 100.0;

	ld	[%fp-96],%l0
	st	%l0,[%fp-200]
	ld	[%fp-200],%f2
	fitod	%f2,%f4
	ld	[%fp-92],%l0
	st	%l0,[%fp-200]
	ld	[%fp-200],%f2
	fitod	%f2,%f2
	fdivd	%f4,%f2,%f4
	sethi	%hi(.L_cseg0),%l0
	or	%l0,%lo(.L_cseg0),%l0
	ldd	[%l0+0],%f2
	fmuld	%f4,%f2,%f2
	std	%f2,[%fp-120]

!  186	  if (imagefile == NULL)

	sethi	%hi(imagefile),%l0
	or	%l0,%lo(imagefile),%l0
	ld	[%l0+0],%l1
	mov	0,%l0
	cmp	%l1,%l0
	bne	.L129
	nop

	! block 35
.L130:

!  187	  { printf("Setting heap limit as follows:\n");

	sethi	%hi(.L131),%l0
	or	%l0,%lo(.L131),%l0
	mov	%l0,%o0
	call	printf
	nop

!  188	    printf("Total heap & bps space = %d (%X), bps = %.2f, heap = %.2f\n",
!  189	          total, total, bpspercent, heappercent);

	sethi	%hi(.L132),%l0
	or	%l0,%lo(.L132),%l0
	ld	[%fp-92],%l1
	ld	[%fp-92],%l2
	ldd	[%fp-120],%f2
	ldd	[%fp-128],%f4
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	std	%f2,[%sp+88]
	ld	[%sp+88],%o3
	ld	[%sp+92],%o4
	std	%f4,[%sp+88]
	ld	[%sp+88],%o5
	call	printf
	nop

	! block 36
.L129:

!  190	  }
!  191	
!  192	  setupbps();

	call	setupbps
	nop

!  193	  getheap(heapsize,feder);

	ld	[%fp-100],%l0
	ld	[%fp-44],%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	getheap
	nop

!  195	  free (ii2); free(ii4); free (ii6); free(ii8);

	ld	[%fp-148],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-156],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-164],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-172],%l0
	mov	%l0,%o0
	call	free
	nop

!  196	  free (ii1); free (ii3); free (ii5); free(ii7);

	ld	[%fp-144],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-152],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-160],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-168],%l0
	mov	%l0,%o0
	call	free
	nop

!  197	  free (ii11); free (ii9); free (ii10);

	ld	[%fp-184],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-176],%l0
	mov	%l0,%o0
	call	free
	nop
	ld	[%fp-180],%l0
	mov	%l0,%o0
	call	free
	nop

!  200	  if (imagefile == NULL)

	sethi	%hi(imagefile),%l0
	or	%l0,%lo(imagefile),%l0
	ld	[%l0+0],%l1
	mov	0,%l0
	cmp	%l1,%l0
	bne	.L136
	nop

	! block 37
.L137:

!  201	  printf("bpssize = %d (%X), heapsize = %d (%X)\nTotal image size = %d (%X)\n",
!  202	          bpssize, bpssize,
!  203	          heapsize, heapsize,
!  204	          (int) sbrk(0), (int) sbrk(0));

	sethi	%hi(.L138),%l1
	or	%l1,%lo(.L138),%l1
	ld	[%fp-96],%l2
	ld	[%fp-96],%l3
	ld	[%fp-100],%l5
	ld	[%fp-100],%l6
	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l7
	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l0
	mov	%l1,%o0
	mov	%l2,%o1
	mov	%l3,%o2
	mov	%l5,%o3
	mov	%l6,%o4
	mov	%l7,%o5
	st	%l0,[%sp+92]
	call	printf
	nop

	! block 38
.L136:

!  207	   if (imagefile != NULL) {

	sethi	%hi(imagefile),%l0
	or	%l0,%lo(imagefile),%l0
	ld	[%l0+0],%l1
	mov	0,%l0
	cmp	%l1,%l0
	be	.L139
	nop

	! block 39
.L140:

!  208	        ohlb = OLDHEAPLOWERBOUND; ohub = OLDHEAPUPPERBOUND;

	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-16]
	sethi	%hi(OLDHEAPUPPERBOUND),%l0
	or	%l0,%lo(OLDHEAPUPPERBOUND),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-20]

!  209	        ohl = OLDHEAPLAST;    ohtb = OLDHEAPTRAPBOUND;

	sethi	%hi(OLDHEAPLAST),%l0
	or	%l0,%lo(OLDHEAPLAST),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-8]
	sethi	%hi(OLDHEAPTRAPBOUND),%l0
	or	%l0,%lo(OLDHEAPTRAPBOUND),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-12]

!  210	        hlb = HEAPLOWERBOUND; hub = HEAPUPPERBOUND;

	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-32]
	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-36]

!  211	        hl  = HEAPLAST;       htb = HEAPTRAPBOUND;

	sethi	%hi(HEAPLAST),%l0
	or	%l0,%lo(HEAPLAST),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-24]
	sethi	%hi(HEAPTRAPBOUND),%l0
	or	%l0,%lo(HEAPTRAPBOUND),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-28]

!  212	    /* save the new values around restore of the old ones */
!  213	
!  214	       printf("Loading image file: %s \n",imagefile);

	sethi	%hi(.L141),%l1
	or	%l1,%lo(.L141),%l1
	sethi	%hi(imagefile),%l0
	or	%l0,%lo(imagefile),%l0
	ld	[%l0+0],%l0
	mov	%l1,%o0
	mov	%l0,%o1
	call	printf
	nop

!  215	       imago = fopen (imagefile,"r");

	sethi	%hi(imagefile),%l0
	or	%l0,%lo(imagefile),%l0
	ld	[%l0+0],%l0
	sethi	%hi(.L142),%l1
	or	%l1,%lo(.L142),%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	fopen
	nop
	mov	%o0,%l0
	st	%l0,[%fp-48]

!  216	       if (imago == NULL) { perror ("error"); exit (-1); }

	ld	[%fp-48],%l1
	mov	0,%l0
	cmp	%l1,%l0
	bne	.L143
	nop

	! block 40
.L144:
	sethi	%hi(.L146),%l0
	or	%l0,%lo(.L146),%l0
	mov	%l0,%o0
	call	perror
	nop
	mov	-1,%l0
	mov	%l0,%o0
	call	exit
	nop

	! block 41
.L143:

!  217	       fread (headerword,4,8,imago);

	add	%fp,-84,%l0
	mov	4,%l1
	mov	8,%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  219	       if (strcmp(headerword,datetag()))

	add	%fp,-84,%l0
	call	datetag
	nop
	mov	%o0,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	strcmp
	nop
	mov	%o0,%l0
	cmp	%l0,%g0
	be	.L150
	nop

	! block 42
.L151:

!  220	                { printf(" Cannot start the image with this bpsl \n");

	sethi	%hi(.L152),%l0
	or	%l0,%lo(.L152),%l0
	mov	%l0,%o0
	call	printf
	nop

!  221	                  exit (-19); } 

	mov	-19,%l0
	mov	%l0,%o0
	call	exit
	nop

	! block 43
.L150:

!  223	       fread (headerword,4,8,imago);

	add	%fp,-84,%l0
	mov	4,%l1
	mov	8,%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  224	       fread (&SYMVAL,1,headerword[0],imago);

	sethi	%hi(SYMVAL),%l0
	or	%l0,%lo(SYMVAL),%l0
	mov	1,%l1
	ld	[%fp-84],%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  225	       /* printf (" HEAPLOWERBOUND = %x (new) %x (file)\n" HEAPLOWERBOUND,
!  226	                        headerword[6]); */
!  227	        if(headerword[7] > HEAPLOWERBOUND + feder/2) {

	ld	[%fp-56],%l3
	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l2
	ld	[%fp-44],%l0
	mov	2,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	.div
	nop
	mov	%o0,%l1
	add	%l2,%l1,%l0
	cmp	%l3,%l0
	ble	.L153
	nop

	! block 44
.L154:

!  228	                printf (" Cant relocate the image"); exit (-3); }

	sethi	%hi(.L155),%l0
	or	%l0,%lo(.L155),%l0
	mov	%l0,%o0
	call	printf
	nop
	mov	-3,%l0
	mov	%l0,%o0
	call	exit
	nop

	! block 45
.L153:

!  229	        if(headerword[7] < HEAPLOWERBOUND - feder/2) {

	ld	[%fp-56],%l3
	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l2
	ld	[%fp-44],%l0
	mov	2,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	.div
	nop
	mov	%o0,%l1
	sub	%l2,%l1,%l0
	cmp	%l3,%l0
	bge	.L156
	nop

	! block 46
.L157:

!  230	                printf (" Cant relocate the image"); exit (-3); }

	sethi	%hi(.L158),%l0
	or	%l0,%lo(.L158),%l0
	mov	%l0,%o0
	call	printf
	nop
	mov	-3,%l0
	mov	%l0,%o0
	call	exit
	nop

	! block 47
.L156:

!  231	       feder = HEAPLOWERBOUND - headerword[7];

	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l0
	ld	[%fp-56],%l1
	sub	%l0,%l1,%l0
	st	%l0,[%fp-44]

!  232	       fread ((char *) headerword[7],1,headerword[1],imago);

	ld	[%fp-56],%l0
	mov	1,%l1
	ld	[%fp-80],%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  233	       fread (&VIVAREA,1,headerword[2],imago);

	sethi	%hi(VIVAREA),%l0
	or	%l0,%lo(VIVAREA),%l0
	mov	1,%l1
	ld	[%fp-76],%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  234	       fread (&HASHTABLE,1,headerword[3],imago);

	sethi	%hi(HASHTABLE),%l0
	or	%l0,%lo(HASHTABLE),%l0
	mov	1,%l1
	ld	[%fp-72],%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  235	       fread ((char *) BPSLOWERBOUND,1,headerword[4],imago);

	sethi	%hi(BPSLOWERBOUND),%l0
	or	%l0,%lo(BPSLOWERBOUND),%l0
	ld	[%l0+0],%l0
	mov	1,%l1
	ld	[%fp-68],%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  236	       fread ((char *) headerword[5],1,headerword[6],imago);

	ld	[%fp-64],%l0
	mov	1,%l1
	ld	[%fp-60],%l2
	ld	[%fp-48],%l3
	mov	%l0,%o0
	mov	%l1,%o1
	mov	%l2,%o2
	mov	%l3,%o3
	call	fread
	nop

!  237	       fclose (imago);

	ld	[%fp-48],%l0
	mov	%l0,%o0
	call	fclose
	nop

!  238	           OLDHEAPLOWERBOUND = ohlb -feder; 

	ld	[%fp-16],%l0
	ld	[%fp-44],%l1
	sub	%l0,%l1,%l1
	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	st	%l1,[%l0+0]

!  239	           OLDHEAPUPPERBOUND = ohub -feder;

	ld	[%fp-20],%l0
	ld	[%fp-44],%l1
	sub	%l0,%l1,%l1
	sethi	%hi(OLDHEAPUPPERBOUND),%l0
	or	%l0,%lo(OLDHEAPUPPERBOUND),%l0
	st	%l1,[%l0+0]

!  240	           OLDHEAPLAST  =  ohl -feder;   

	ld	[%fp-8],%l0
	ld	[%fp-44],%l1
	sub	%l0,%l1,%l1
	sethi	%hi(OLDHEAPLAST),%l0
	or	%l0,%lo(OLDHEAPLAST),%l0
	st	%l1,[%l0+0]

!  241	           OLDHEAPTRAPBOUND = ohtb -feder;

	ld	[%fp-12],%l0
	ld	[%fp-44],%l1
	sub	%l0,%l1,%l1
	sethi	%hi(OLDHEAPTRAPBOUND),%l0
	or	%l0,%lo(OLDHEAPTRAPBOUND),%l0
	st	%l1,[%l0+0]

!  242	           HEAPUPPERBOUND = hub -feder;

	ld	[%fp-36],%l0
	ld	[%fp-44],%l1
	sub	%l0,%l1,%l1
	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	st	%l1,[%l0+0]

!  243	           HEAPTRAPBOUND = htb -feder; 

	ld	[%fp-28],%l0
	ld	[%fp-44],%l1
	sub	%l0,%l1,%l1
	sethi	%hi(HEAPTRAPBOUND),%l0
	or	%l0,%lo(HEAPTRAPBOUND),%l0
	st	%l1,[%l0+0]

!  244	       return (4711);

	sethi	%hi(4711),%l0
	or	%l0,%lo(4711),%l0
	st	%l0,[%fp-4]
	ba	.L81
	nop

	! block 48
.L139:

!  245	     }
!  246	return (0);

	mov	0,%l0
	st	%l0,[%fp-4]
	ba	.L81
	nop

	! block 49
.L81:
	ld	[%fp-4],%l0
	mov	%l0,%i0
	jmp	%i7+8
	restore
	.size	setupbpsandheap,(.-setupbpsandheap)
	.align	8
	.align	8
	.skip	16

	! block 0

	.global	setupbps
	.type	setupbps,2
setupbps:
	save	%sp,-96,%sp

	! block 1
.L161:

! File /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c:
!  248	}
!  249	
!  251	/* The current procedure is to convert the starting address of the char
!  252	   array defined in bps.c to an address and store it in NEXTBPS. A check
!  253	   is made to make sure that NEXTBPS falls on an even word boundry.
!  254	 */
!  255	
!  256	setupbps()
!  257	{ BPSLOWERBOUND = ((int)bps + 3) & ~3;

	sethi	%hi(bps+3),%l0
	or	%l0,%lo(bps+3),%l0
	and	%l0,-4,%l1
	sethi	%hi(BPSLOWERBOUND),%l0
	or	%l0,%lo(BPSLOWERBOUND),%l0
	st	%l1,[%l0+0]

!  258	  NEXTBPS  = ((int)bps + 3) & ~3;        /* Up to a multiple of 4. */

	sethi	%hi(bps+3),%l0
	or	%l0,%lo(bps+3),%l0
	and	%l0,-4,%l1
	sethi	%hi(NEXTBPS),%l0
	or	%l0,%lo(NEXTBPS),%l0
	st	%l1,[%l0+0]

!  259	  LASTBPS  = ((int)bps + BPSSIZE) & ~3;    /* Down to a multiple of 4. */

	sethi	%hi(bps+4000000),%l0
	or	%l0,%lo(bps+4000000),%l0
	and	%l0,-4,%l1
	sethi	%hi(LASTBPS),%l0
	or	%l0,%lo(LASTBPS),%l0
	st	%l1,[%l0+0]

	! block 2
.L160:
	jmp	%i7+8
	restore
	.size	setupbps,(.-setupbps)
	.align	8
	.align	8
	.skip	16

	! block 0

	.global	allocatemorebps
	.type	allocatemorebps,2
allocatemorebps:
	save	%sp,-112,%sp

	! block 1
.L165:

! File /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c:
!  260	}
!  261	
!  263	/* Allocate alternate bps space. Note: The use of sbrk(), and the fact that
!  264	   NEXTBPS is now greater than HEAPLAST means that unexec should be not be
!  265	   tried after this routine is called. The image would be huge.
!  266	 */
!  267	allocatemorebps()
!  268	{
!  269	  int current_size_in_bytes;
!  270	  int old_NEXTBPS = NEXTBPS;

	sethi	%hi(NEXTBPS),%l0
	or	%l0,%lo(NEXTBPS),%l0
	ld	[%l0+0],%l0
	st	%l0,[%fp-12]

!  272	  current_size_in_bytes = sbrk(0);

	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l0
	st	%l0,[%fp-8]

!  274	  if ((current_size_in_bytes + EXTRABPSSIZE) >= max_image_size)

	ld	[%fp-8],%l0
	sethi	%hi(100000),%l1
	or	%l1,%lo(100000),%l1
	add	%l0,%l1,%l1
	sethi	%hi(max_image_size),%l0
	or	%l0,%lo(max_image_size),%l0
	ld	[%l0+0],%l0
	cmp	%l1,%l0
	bl	.L166
	nop

	! block 2
.L167:

!  275	    return(0);

	mov	0,%l0
	st	%l0,[%fp-4]
	ba	.L164
	nop

	! block 3
.L166:

!  277	  if (((int)sbrk(0)) % 2)      /* force to even word boundary*/

	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l0
	mov	2,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	.rem
	nop
	mov	%o0,%l0
	cmp	%l0,%g0
	be	.L168
	nop

	! block 4
.L169:

!  278	     NEXTBPS = (int)sbrk(1);

	mov	1,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l1
	sethi	%hi(NEXTBPS),%l0
	or	%l0,%lo(NEXTBPS),%l0
	st	%l1,[%l0+0]

	! block 5
.L168:

!  280	  NEXTBPS = (int)sbrk(EXTRABPSSIZE);   /* allocate extra BPS */

	sethi	%hi(100000),%l0
	or	%l0,%lo(100000),%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l1
	sethi	%hi(NEXTBPS),%l0
	or	%l0,%lo(NEXTBPS),%l0
	st	%l1,[%l0+0]

!  281	  if (NEXTBPS == -1) {

	sethi	%hi(NEXTBPS),%l0
	or	%l0,%lo(NEXTBPS),%l0
	ld	[%l0+0],%l0
	cmp	%l0,-1
	bne	.L170
	nop

	! block 6
.L171:

!  282	    NEXTBPS = old_NEXTBPS;

	ld	[%fp-12],%l1
	sethi	%hi(NEXTBPS),%l0
	or	%l0,%lo(NEXTBPS),%l0
	st	%l1,[%l0+0]

!  283	    return(0);

	mov	0,%l0
	st	%l0,[%fp-4]
	ba	.L164
	nop

	! block 7
.L170:

!  284	  }
!  285	  LASTBPS = NEXTBPS + EXTRABPSSIZE;

	sethi	%hi(NEXTBPS),%l0
	or	%l0,%lo(NEXTBPS),%l0
	ld	[%l0+0],%l0
	sethi	%hi(100000),%l1
	or	%l1,%lo(100000),%l1
	add	%l0,%l1,%l1
	sethi	%hi(LASTBPS),%l0
	or	%l0,%lo(LASTBPS),%l0
	st	%l1,[%l0+0]

!  286	  return(EXTRABPSSIZE);   /* This will be a paramter later */

	sethi	%hi(100000),%l0
	or	%l0,%lo(100000),%l0
	st	%l0,[%fp-4]
	ba	.L164
	nop

	! block 8
.L164:
	ld	[%fp-4],%l0
	mov	%l0,%i0
	jmp	%i7+8
	restore
	.size	allocatemorebps,(.-allocatemorebps)
	.align	8
	.align	8
	.skip	16

	! block 0

	.global	getheap
	.type	getheap,2
getheap:
	save	%sp,-96,%sp
	st	%i1,[%fp+72]
	st	%i0,[%fp+68]

	! block 1
.L174:

! File /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c:
!  287	}
!  288	
!  290	/* tag( getheap )
!  291	 */
!  292	
!  293	getheap(heapsize,feder)
!  294	     int heapsize,feder;
!  295	{
!  296	  HEAPLOWERBOUND        = (int)sbrk(2 * heapsize + feder );

	ld	[%fp+68],%l0
	sll	%l0,1,%l0
	ld	[%fp+72],%l1
	add	%l0,%l1,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l1
	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	st	%l1,[%l0+0]

!  297	                  /* allocate first heap */;
!  298	  
!  299	  if (HEAPLOWERBOUND == -1) {

	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l0
	cmp	%l0,-1
	bne	.L175
	nop

	! block 2
.L176:

!  300	    perror("GETHEAP");

	sethi	%hi(.L177),%l0
	or	%l0,%lo(.L177),%l0
	mov	%l0,%o0
	call	perror
	nop

!  301	    exit(-1);

	mov	-1,%l0
	mov	%l0,%o0
	call	exit
	nop

	! block 3
.L175:

!  302	  }
!  303	     HEAPLOWERBOUND += feder / 2;

	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l2
	ld	[%fp+72],%l0
	mov	2,%l1
	mov	%l0,%o0
	mov	%l1,%o1
	call	.div
	nop
	mov	%o0,%l1
	add	%l2,%l1,%l1
	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	st	%l1,[%l0+0]

!  304	     HEAPLOWERBOUND  = HEAPLOWERBOUND;

	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l1
	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	st	%l1,[%l0+0]

!  305	     HEAPUPPERBOUND  = HEAPLOWERBOUND + heapsize;

	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l0
	ld	[%fp+68],%l1
	add	%l0,%l1,%l1
	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	st	%l1,[%l0+0]

!  306	     HEAPLAST        = HEAPLOWERBOUND;

	sethi	%hi(HEAPLOWERBOUND),%l0
	or	%l0,%lo(HEAPLOWERBOUND),%l0
	ld	[%l0+0],%l1
	sethi	%hi(HEAPLAST),%l0
	or	%l0,%lo(HEAPLAST),%l0
	st	%l1,[%l0+0]

!  307	     HEAPTRAPBOUND   = HEAPUPPERBOUND -120;

	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	ld	[%l0+0],%l0
	sub	%l0,120,%l1
	sethi	%hi(HEAPTRAPBOUND),%l0
	or	%l0,%lo(HEAPTRAPBOUND),%l0
	st	%l1,[%l0+0]

!  309	     OLDHEAPLOWERBOUND = HEAPUPPERBOUND;

	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	ld	[%l0+0],%l1
	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	st	%l1,[%l0+0]

!  310	     OLDHEAPUPPERBOUND = OLDHEAPLOWERBOUND + heapsize;

	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	ld	[%l0+0],%l0
	ld	[%fp+68],%l1
	add	%l0,%l1,%l1
	sethi	%hi(OLDHEAPUPPERBOUND),%l0
	or	%l0,%lo(OLDHEAPUPPERBOUND),%l0
	st	%l1,[%l0+0]

!  311	     OLDHEAPLAST       = OLDHEAPLOWERBOUND;

	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	ld	[%l0+0],%l1
	sethi	%hi(OLDHEAPLAST),%l0
	or	%l0,%lo(OLDHEAPLAST),%l0
	st	%l1,[%l0+0]

!  312	     OLDHEAPTRAPBOUND  = OLDHEAPUPPERBOUND -120;

	sethi	%hi(OLDHEAPUPPERBOUND),%l0
	or	%l0,%lo(OLDHEAPUPPERBOUND),%l0
	ld	[%l0+0],%l0
	sub	%l0,120,%l1
	sethi	%hi(OLDHEAPTRAPBOUND),%l0
	or	%l0,%lo(OLDHEAPTRAPBOUND),%l0
	st	%l1,[%l0+0]

!  314	     oldbreakvalue = (int)sbrk(0);

	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l1
	sethi	%hi(oldbreakvalue),%l0
	or	%l0,%lo(oldbreakvalue),%l0
	st	%l1,[%l0+0]

	! block 4
.L173:
	jmp	%i7+8
	restore
	.size	getheap,(.-getheap)
	.align	8
	.align	8
	.skip	16

	! block 0

	.global	alterheapsize
	.type	alterheapsize,2
alterheapsize:
	save	%sp,-112,%sp
	st	%i0,[%fp+68]

	! block 1
.L181:

! File /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c:
!  315	}
!  316	
!  318	/* Tag( alterheapsize )
!  319	 */
!  320	
!  321	alterheapsize(increment)
!  322	
!  323	int increment;
!  324	
!  325	{
!  326	/*
!  327	  alters the size of the heap by the specified increment.  Returns
!  328	  the increment if successful, otherwise returns 0.  May fai i
!  329	  the sbrk is unsuccessful or if the user tries to cut the heap back
!  330	  to nothing or the current break value does not match the old value.
!  331	  The latter case occurs when a malloc or sbrk has allocated space for
!  332	  some other software, in which case we cannot allocate any more space
!  333	  contiguously.
!  334	
!  335	  Modifies both the heap and gcarray size.
!  336	  NOTE: a garbage collection should probably be performed before this
!  337	    routine is called.
!  338	  NOTE: only implemented for the one heap version on the 68000.
!  339	*/
!  340	
!  341	  int heapsize;
!  342	  int current_size_in_bytes;
!  343	
!  344	  /* assumes the current heap is the 'lower' one */
!  345	  int newbreakvalue;
!  346	
!  347	  if ((int) sbrk(0) != oldbreakvalue)  /* Non contiguous memory */

	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l1
	sethi	%hi(oldbreakvalue),%l0
	or	%l0,%lo(oldbreakvalue),%l0
	ld	[%l0+0],%l0
	cmp	%l1,%l0
	be	.L182
	nop

	! block 2
.L183:

!  348	      {  printf(" unable to allocate %x %x\n",sbrk(0),oldbreakvalue);

	sethi	%hi(.L184),%l1
	or	%l1,%lo(.L184),%l1
	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l2
	sethi	%hi(oldbreakvalue),%l0
	or	%l0,%lo(oldbreakvalue),%l0
	ld	[%l0+0],%l0
	mov	%l1,%o0
	mov	%l2,%o1
	mov	%l0,%o2
	call	printf
	nop

!  349	        return(0); }

	mov	0,%l0
	st	%l0,[%fp-4]
	ba	.L180
	nop

	! block 3
.L182:

!  351	  current_size_in_bytes = ( (int) sbrk(0) <<5) >>5;

	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l0
	sll	%l0,5,%l0
	sra	%l0,5,%l0
	st	%l0,[%fp-12]

!  353	  if ((current_size_in_bytes + 2* increment) >= max_image_size)

	ld	[%fp-12],%l2
	ld	[%fp+68],%l0
	sll	%l0,1,%l1
	add	%l2,%l1,%l1
	sethi	%hi(max_image_size),%l0
	or	%l0,%lo(max_image_size),%l0
	ld	[%l0+0],%l0
	cmp	%l1,%l0
	bl	.L185
	nop

	! block 4
.L186:

!  354	    return(-1);

	mov	-1,%l0
	st	%l0,[%fp-4]
	ba	.L180
	nop

	! block 5
.L185:

!  356	  if ((int)sbrk(2 * increment) == -1)       /* the sbrk failed. */

	ld	[%fp+68],%l0
	sll	%l0,1,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l0
	cmp	%l0,-1
	bne	.L187
	nop

	! block 6
.L188:

!  357	     return(-2);

	mov	-2,%l0
	st	%l0,[%fp-4]
	ba	.L180
	nop

	! block 7
.L187:

!  359	  newbreakvalue = (int) sbrk(0);

	mov	0,%l0
	mov	%l0,%o0
	call	sbrk
	nop
	mov	%o0,%l0
	st	%l0,[%fp-16]

!  361	  HEAPUPPERBOUND        = HEAPUPPERBOUND + increment ;

	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	ld	[%l0+0],%l0
	ld	[%fp+68],%l1
	add	%l0,%l1,%l1
	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	st	%l1,[%l0+0]

!  362	  HEAPTRAPBOUND         = HEAPUPPERBOUND - 120;

	sethi	%hi(HEAPUPPERBOUND),%l0
	or	%l0,%lo(HEAPUPPERBOUND),%l0
	ld	[%l0+0],%l0
	sub	%l0,120,%l1
	sethi	%hi(HEAPTRAPBOUND),%l0
	or	%l0,%lo(HEAPTRAPBOUND),%l0
	st	%l1,[%l0+0]

!  363	  OLDHEAPLOWERBOUND     = OLDHEAPLOWERBOUND + increment;

	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	ld	[%l0+0],%l0
	ld	[%fp+68],%l1
	add	%l0,%l1,%l1
	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	st	%l1,[%l0+0]

!  364	  OLDHEAPUPPERBOUND     = OLDHEAPUPPERBOUND + 2* increment ;

	sethi	%hi(OLDHEAPUPPERBOUND),%l0
	or	%l0,%lo(OLDHEAPUPPERBOUND),%l0
	ld	[%l0+0],%l2
	ld	[%fp+68],%l0
	sll	%l0,1,%l1
	add	%l2,%l1,%l1
	sethi	%hi(OLDHEAPUPPERBOUND),%l0
	or	%l0,%lo(OLDHEAPUPPERBOUND),%l0
	st	%l1,[%l0+0]

!  365	  OLDHEAPLAST           = OLDHEAPLOWERBOUND;

	sethi	%hi(OLDHEAPLOWERBOUND),%l0
	or	%l0,%lo(OLDHEAPLOWERBOUND),%l0
	ld	[%l0+0],%l1
	sethi	%hi(OLDHEAPLAST),%l0
	or	%l0,%lo(OLDHEAPLAST),%l0
	st	%l1,[%l0+0]

!  366	  OLDHEAPTRAPBOUND      = OLDHEAPUPPERBOUND -120;

	sethi	%hi(OLDHEAPUPPERBOUND),%l0
	or	%l0,%lo(OLDHEAPUPPERBOUND),%l0
	ld	[%l0+0],%l0
	sub	%l0,120,%l1
	sethi	%hi(OLDHEAPTRAPBOUND),%l0
	or	%l0,%lo(OLDHEAPTRAPBOUND),%l0
	st	%l1,[%l0+0]

!  369	  oldbreakvalue = newbreakvalue;

	ld	[%fp-16],%l1
	sethi	%hi(oldbreakvalue),%l0
	or	%l0,%lo(oldbreakvalue),%l0
	st	%l1,[%l0+0]

!  370	  return(increment);

	ld	[%fp+68],%l0
	st	%l0,[%fp-4]
	ba	.L180
	nop

	! block 8
.L180:
	ld	[%fp-4],%l0
	mov	%l0,%i0
	jmp	%i7+8
	restore
	.size	alterheapsize,(.-alterheapsize)
	.align	8
	.align	8
	.skip	16

	! block 0

	.global	unexec
	.type	unexec,2
unexec:
	save	%sp,-104,%sp

	! block 1
.L192:

! File /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c:
!  371	}
!  372	
!  373	unexec ()
!  374	  { return (BPSSIZE); }

	sethi	%hi(4000000),%l0
	or	%l0,%lo(4000000),%l0
	st	%l0,[%fp-4]
	ba	.L191
	nop

	! block 2
.L191:
	ld	[%fp-4],%l0
	mov	%l0,%i0
	jmp	%i7+8
	restore
	.size	unexec,(.-unexec)
	.align	8

	.section	".data1",#alloc,#write
	.align	4
.L89:
	.skip	4
	.type	.L89,#object
	.size	.L89,4
	.align	4
.L96:
	.ascii	"%x\000"
	.skip	1
	.type	.L96,#object
	.size	.L96,4
	.align	4
.L98:
	.ascii	"%d\000"
	.skip	1
	.type	.L98,#object
	.size	.L98,4
	.align	4
.L104:
	.ascii	"%x\000"
	.skip	1
	.type	.L104,#object
	.size	.L104,4
	.align	4
.L106:
	.ascii	"%d\000"
	.skip	1
	.type	.L106,#object
	.size	.L106,4
	.common	imagefile,4,4
	.align	4
.L110:
	.ascii	"%d\000"
	.skip	1
	.type	.L110,#object
	.size	.L110,4
	.align	4
.L123:
	.ascii	"hugo\000"
	.skip	3
	.type	.L123,#object
	.size	.L123,8
	.common	max_image_size,4,4
	.align	4
.L127:
	.ascii	"Size requested will result in pointer values larger than\n\000"
	.skip	2
	.type	.L127,#object
	.size	.L127,60
	.align	4
.L128:
	.ascii	" PSL items can handle. Will allocate maximum size instead.\n\n\000"
	.skip	3
	.type	.L128,#object
	.size	.L128,64
	.align	4
.L131:
	.ascii	"Setting heap limit as follows:\n\000"
	.type	.L131,#object
	.size	.L131,32
	.align	4
.L132:
	.ascii	"Total heap & bps space = %d (%X), bps = %.2f, heap = %.2f\n\000"
	.skip	1
	.type	.L132,#object
	.size	.L132,60
	.align	4
.L138:
	.ascii	"bpssize = %d (%X), heapsize = %d (%X)\nTotal image size = %d (%X)\n\000"
	.skip	2
	.type	.L138,#object
	.size	.L138,68
	.align	4
.L141:
	.ascii	"Loading image file: %s \n\000"
	.skip	3
	.type	.L141,#object
	.size	.L141,28
	.align	4
.L142:
	.ascii	"r\000"
	.skip	2
	.type	.L142,#object
	.size	.L142,4
	.align	4
.L146:
	.ascii	"error\000"
	.skip	2
	.type	.L146,#object
	.size	.L146,8
	.align	4
.L152:
	.ascii	" Cannot start the image with this bpsl \n\000"
	.skip	3
	.type	.L152,#object
	.size	.L152,44
	.align	4
.L155:
	.ascii	" Cant relocate the image\000"
	.skip	3
	.type	.L155,#object
	.size	.L155,28
	.align	4
.L158:
	.ascii	" Cant relocate the image\000"
	.skip	3
	.type	.L158,#object
	.size	.L158,28

	.section	".rodata",#alloc
	.align	8
.L_cseg0:
	.word	0x40590000,0x0
	.type	.L_cseg0,#object
	.size	.L_cseg0,8

	.section	".data1",#alloc,#write
	.align	4
.L177:
	.ascii	"GETHEAP\000"
	.type	.L177,#object
	.size	.L177,8
	.common	oldbreakvalue,4,4
	.align	4
.L184:
	.ascii	" unable to allocate %x %x\n\000"
	.type	.L184,#object
	.size	.L184,27

	.file	"bpsheap.c"
	.xstabs	".stab.index","Xs ; V=3.0 ; R=3.0",60,0,0,0
	.xstabs	".stab.index","/silo/cons/verkaufpsl/dist/kernel/solaris; /opt/SUNWspro/SC3.0.1/bin/acc -Xs -YP,:/usr/ucblib:/opt/SUNWspro/SC3.0.1/bin/../lib:/opt/SUNWspro/SC3.0.1/bin:/usr/ccs/lib:/usr/lib -S -DBPSSIZE='4000000' -I/usr/ucbinclude  -c /silo/cons/verkaufpsl/dist/kernel/solaris/bpsheap.c -Qoption acomp -xp",52,0,0,0
	.ident	"@(#)stdio.h	1.1	90/04/27 SMI"
	.ident	"acomp: SC3.0.1 07 Nov 1994 Sun C 3.0.1 patch 101909-03"
